﻿@using Microsoft.Extensions.Localization
@using System.ComponentModel.DataAnnotations
@using System.IO
@using System.IO.Compression
@using System.Text
@using ElectronNET.API
@using ElectronNET.API.Entities
@using OTaskForce.Singletons

@inject NavigationManager _navigationManager
@inject IStringLocalizer<ExportTaskModal> _localizer
@inject ProjectsOperator _projectsOperator

@if (_publishModal)
{
    <div class="modal fade" id="ExportTaskModal" tabindex="-1">
        <div class="modal-dialog modal-lg modal-dialog-centered modal-dialog-scrollable">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">@_localizer["Експорт завдання"]</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
                </div>
                <div class="modal-body">
                    <p>
                        @_localizer["Якщо ви редагуєте вже існуюче завдання, не забудьте завчасно зробити бекап його поточної версії."]
                        @_localizer["У випадку, коли ви створюєте нове завдання на основі вже існуючого, не забудьте змінити ідентифікатор нового завдання у розділі \"Умови завдання\"."]
                        @_localizer["Перезапис (редагування) існуючого завдання починає процес повторної перевірки усіх розв'язків, поданих до нього."]
                        @_localizer["Перед експортом завдання, перевірте:"]
                    </p>
                    <ol>
                        <li>@_localizer["Наявність умов завдання, його первинних налаштувань"]</li>
                        <li>@_localizer["Відповідність тестових даних умовам завдання"]</li>
                        <li>@_localizer["Наявність файлів і папок, які використовуються у процесі тестування розв'язків до завдання"]</li>
                    </ol>
                    <div class="d-grid">
                        <button type="button" class="btn btn-lg btn-dark" @onclick="(async () => await ExportProjectAsync())" data-bs-dismiss="modal">
                            <i class="fas fa-cube"></i>
                            <span>@_localizer["Експортувати завдання"]</span>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
}

@* Export in progress state information panel *@
@if (_publishModal && _exportInProgress)
{
    <section class="position-fixed bg-white d-flex justify-content-center" style="top: 0; bottom: 0; left: 0; right: 0;">
        <div class="align-self-center">
            <div class="d-flex justify-content-center">
                <h4>@_localizer["Експорт завдання..."]</h4>
                <div class="ps-1 pe-1">&nbsp;</div>
                <div class="spinner-border text-dark"></div>
            </div>
            <small class="text-muted text-center">@_localizer["Цей процес триватиме не більше 30 секунд."]</small>
        </div>
    </section>
}
@* /Export in progress state information panel *@

@code
{
    private bool _publishModal = false;
    private bool _exportInProgress = false;
    
    protected override void OnInitialized()
    {
        if (_projectsOperator.CurrentProjectControl.HasProjectOpened)
            _publishModal = true;
    }

    private async Task ExportProjectAsync()
    {
        _exportInProgress = true;
        
        var programmingTaskId = Guid.NewGuid(); // TODO: Get programming task id from project's configuration file
        var zipArchivePath = Path.Combine(_projectsOperator.DefaultProjectsDirectoryFullPath, $"{programmingTaskId}.zip");
        
        // Create a new ZIP archive with optimal compression, containing programming task's configuration files
        ZipFile.CreateFromDirectory(_projectsOperator.CurrentProjectControl.ProjectDirectoryFullPath,
            zipArchivePath, CompressionLevel.Optimal, false, Encoding.UTF8);
        
        _exportInProgress = false;
        
        // Show created ZIP archive in folder, ready to be imported into Overtest
        await Electron.Shell.ShowItemInFolderAsync(zipArchivePath);
        
        // We need to update the state of this component now to prevent "export in progress" panel from being displayed
        StateHasChanged();
    }
}